grml2usb docs: drop references to deprecated grml-medium
[grml2usb.git] / grml2iso
index e84e267..3e48688 100755 (executable)
--- a/grml2iso
+++ b/grml2iso
@@ -1,26 +1,20 @@
 #!/usr/bin/env bash
 # Filename:      grml2iso
 # Purpose:       create a multiboot grml ISO using grml2usb
-# Authors:       Michael Prokop <mika@grml.org>,
-#                Thorsten Glaser <tg@mirbsd.org>
+# Authors:       Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2 or any later version.
 ################################################################################
 
-# define function getfilesize before "set -e" {{{
-  if stat --help >/dev/null 2>&1; then
-    getfilesize='stat -c %s'        # GNU stat
-  else
-    getfilesize='stat -f %z'        # BSD stat
-  fi
-# }}}
+set -e -o pipefail
+
+# make sure we have the sbin directories in our PATH to find grml2usb ootb
+PATH="${PATH}:/sbin:/usr/local/sbin:/usr/sbin"
 
 # adjust variables if necessary through environment {{{
 # path to the grml2usb script you'd like to use
-  [ -n "$GRML2USB" ] || GRML2USB='grml2usb'
-# work directory for creating the filesystem
-  [ -n "$TMPDIR" ]   && WRKDIR="${TMPDIR}/grml2iso.tmp"
-  [ -n "$WRKDIR" ]   || WRKDIR='/tmp/grml2iso.tmp'
+[ -n "$GRML2USB" ] || GRML2USB='grml2usb'
+
 # support mkisofs as well as genisoimage
 if which xorriso >/dev/null 2>&1 ; then
   MKISOFS='xorriso -as mkisofs'
@@ -29,19 +23,17 @@ elif which mkisofs >/dev/null 2>&1; then
 elif which genisoimage >/dev/null 2>&1; then
   MKISOFS='genisoimage'
 else
-  echo >&2 "Error: neither mkisofs nor genisoimage available - can not create ISO."
+  echo "Error: neither xorriso nor mkisofs nor genisoimage available - can not create ISO." >&2
   exit 1
 fi
 
 if ! which isohybrid >/dev/null 2>&1 ; then
-  echo "Error: isohybrid executable not found (install syslinux?)." >&2
+  echo "Error: isohybrid executable not found (install syslinux/isolinux/syslinux-utils?)." >&2
   exit 1
 fi
 # }}}
 
 # helper stuff {{{
-  set -e
-
   usage() {
     echo >&2 "Usage: $0 [OPTIONS] -o target.iso source1.iso [source2.iso ...]"
     echo >&2 "
@@ -60,10 +52,11 @@ Options:
                          restrictions in the bootprocess only IPs are allowed.
                          Supported protocols are: http and ftp
      -t Directory        Directory that should be used for temporary files
-                         during build. Defaults to /tmp/grml2iso.tmp if unset.
+                         during build, instead of using a temporary directory
+                         created by mktemp(1).
 
      Examples:
-     $0 -s http://192.168.23.42:8000/grml/ -o small.iso grml64_2010.12.iso
+     $0 -s http://192.168.23.42:8000/grml/ -o small.iso grml64-small_2021.07.iso
 
      Will generate a file small.iso which tries to download the squashfs file from
      http://192.168.23.42:8000/grml/ - the squashfs file is placed in the same
@@ -101,10 +94,6 @@ Options:
     GRML2USB_OPTS+=(--bootoptions="fetch=$URI")
   fi
 
-  if [ -n "$WRKDIR" ] ; then
-    GRML2USB_OPTS+=(--tmpdir="$WRKDIR")
-  fi
-
 # make sure -o is specified
   [ -n "$ISOFILE" ] || usage 1
 
@@ -149,8 +138,16 @@ Options:
   esac
 # }}}
 
-# create necessary stuff under WRKDIR {{{
-  [ -d "$WRKDIR" ] && WRKDIR_EXISTED='true' || WRKDIR_EXISTED='false'
+# ensure to properly set up working directory {{{
+  WRKDIR_EXISTED='false'
+  if [ -z "$WRKDIR" ] ; then
+    WRKDIR="$(mktemp -d)"
+  else
+    [ -d "$WRKDIR" ] && WRKDIR_EXISTED='true'
+  fi
+
+  GRML2USB_OPTS+=(--tmpdir="$WRKDIR")
+
   rm -rf "$WRKDIR/cddir" "$WRKDIR/grub_tmp"
   mkdir -p "$WRKDIR/cddir"
 # }}}}
@@ -179,6 +176,7 @@ Options:
 # efi boot {{{
   # default, independent of UEFI support
   BOOT_ARGS="-no-emul-boot -boot-load-size 4 -boot-info-table -b boot/isolinux/isolinux.bin -c boot/isolinux/boot.cat"
+  UEFI_ENABLE=false
 
   case "$MKISOFS" in
     xorriso*)
@@ -187,15 +185,27 @@ Options:
         echo "Disabling (U)EFI boot support since xorriso version is not recent enough."
       else
         echo "xorriso with -eltorito-alt-boot support present"
+        UEFI_ENABLE=true
 
         if ! [ -r "${WRKDIR}/cddir/boot/efi.img" ] ; then
-          echo "File /boot/efi.img not found, not extending boot arguments for (U)EFI boot."
+          echo "Warning: File /boot/efi.img not found, not extending boot arguments for (U)EFI boot."
+          UEFI_ENABLE=false
         else
           echo "/boot/efi.img found, extending boot arguments for (U)EFI boot."
-          BOOT_ARGS="$BOOT_ARGS -boot-info-table -eltorito-alt-boot -e boot/efi.img -no-emul-boot"
+          if ! [ -r /usr/lib/ISOLINUX/isohdpfx.bin ] ; then
+            echo "Error: /usr/lib/ISOLINUX/isohdpfx.bin not available, required for xorriso/isohybrid though." >&2
+            echo "Hint:  make sure isolinux is installed." >&2
+            exit 1
+          else
+            BOOT_ARGS+=" -boot-info-table -eltorito-alt-boot -e boot/efi.img -no-emul-boot"
+            BOOT_ARGS+=" -isohybrid-mbr /usr/lib/ISOLINUX/isohdpfx.bin -eltorito-alt-boot -e boot/efi.img -no-emul-boot -isohybrid-gpt-basdat -no-pad"
+          fi
         fi
       fi
       ;;
+    *)
+      echo "Using $MKISOFS for ISO generation (lacking UEFI option), disabling (U)EFI boot support."
+      ;;
   esac
 # }}}
 
@@ -263,29 +273,10 @@ Options:
 # }}}
 
 # generate the CD/DVD ISO {{{
-  $MKISOFS -V 'grml-multiboot' -l -r -J -no-pad $BOOT_ARGS \
+  $MKISOFS -V 'grml-multiboot' -l -r -J $BOOT_ARGS \
     -o "$ISOFILE" .
 # }}}
 
-# pad the output ISO to multiples of 256 KiB for partition table support {{{
-  siz=$($getfilesize "$ISOFILE")
-  cyls=$(($siz / 512 / 32 / 16 + 1))  # C=$cyls H=16 S=32
-  ofs=$(($cyls * 16 * 32 * 512 - 1))  # padding offset (size - 1)
-  dd if=/dev/zero bs=1 count=1 seek=$ofs of="$ISOFILE" 2>/dev/null
-# }}}
-
-# make ISO dd-able {{{
-  if isohybrid --help | grep -q -- --uefi ; then
-    echo "isohybrid version supports --uefi option, enabling"
-    ISOHYBRID_OPTIONS=--uefi
- else
-    echo "isohybrid version does NOT support --uefi option, disabling"
-  fi
-
-  echo "Creating dd-able ISO using isohybrid"
-  isohybrid $ISOHYBRID_OPTIONS "$ISOFILE"
-# }}}
-
 # cleanup {{{
   cd "$ORIG_DIR"
   sync
@@ -310,4 +301,4 @@ URI: $URI
 # }}}
 
 ## EOF #########################################################################
-# vim:foldmethod=marker ts=2 ft=sh ai expandtab tw=80 sw=3
+# vim:foldmethod=marker ts=2 ft=sh ai expandtab tw=80 sw=2